<?php

namespace App\Policies;

use App\Models\FacilityMember;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class FacilityMemberPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create facilitymember', 'edit facilitymember', 'view facilitymember', 'delete facilitymember'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, FacilityMember $facilityMember): bool
    {
        return $user->hasPermissionTo('view facilitymember');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create facilitymember');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, FacilityMember $facilityMember): bool
    {
        return $user->hasPermissionTo('edit facilitymember');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, FacilityMember $facilityMember): bool
    {
        return $user->hasPermissionTo('delete facilitymember');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, FacilityMember $facilityMember): bool
    {
        return $user->hasPermissionTo('restore facilitymember');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, FacilityMember $facilityMember): bool
    {
        return $user->hasPermissionTo('force delete facilitymember');
    }
}
